Subject: bug#66503: 29.1; Problem rendering Arabic diacriticals

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 Oct 2023 09:57:48 +0300

> From: John Wiegley <[email-masked]>
> Cc: [email-masked]
> Date: Fri, 13 Oct 2023 22:19:52 -0700
> 
> I have found a workaround: By typing “shadda followed by fatha” instead of
> “fatha followed by shadda”, my Emacs renders it correctly. Here are the two
> different lines:
> 
> لَنَهْدِيَنَّهُمْ
> لَنَهْدِيَنَّهُمْ
> 
> In Mellel these are both rendered the same, but (my) Emacs treats them quite
> differently.

Both lines render identically here.  I think the conclusion is that
the macOS text-shaping engine doesn't sort the combining characters
before rendering them, which is what shaping engines are expected to
do.  However, I don't consider myself an expert on this, so maybe
raise this issue on some forum where the development of the macOS
shaper is discussed?